/**
 * ExtractTopic.java
 */

package tm4jweb.ferdig;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.reflect.Array;

import org.tm4j.topicmap.*;
import org.tm4j.net.*;
import org.tm4j.topicmap.source.*;
import org.tm4j.topicmap.memory.*;
import org.tm4j.topicmap.utils.extractors.*;


public class ExtractTopic{

	// Class variables

    TopicMap tm;
    Topic topicInArray;
    Topic topicTypeTopic, testTopic;
    Topic topicTypeTopic3 = null;
    BaseNamesExtractor baseNamesExtractor = new BaseNamesExtractor();
	BaseName baseName;

    Set topicSet;
    Collection topicNameCollection, topicTypeCollection, topicsOfTypeCollection, nyCollection, returnCollection;
    ArrayList topicTypes = new ArrayList();
    ArrayList topicPropsArrayList = new ArrayList();

    int i = 0;
    int k = 0;
    int numberOfTopics;
	String topicBaseName;

    Object[] objectArray;
    String[] topicNames;
	String[] topicTypesString;
	String[] topicsOfTypeString;


	// Variables for extractTopicsOfType...
	Set topicSet2, anotherSet;
	int topics;
	Iterator topicsIterator;
	Topic topicTypeTopic2, propTopic;

	// constructor
    public ExtractTopic(){
	}

	// Get the characteristics of a specific topic in a topic map
	public ArrayList extractTopicProps(TopicMap map, String topicType){

		tm = map;
		topicSet2 = tm.getTopics();
		anotherSet = tm.getTopics();
		topics = tm.getTopicCount();
		topicsIterator = anotherSet.iterator();

		while(topicsIterator.hasNext()){
			topicTypeTopic2 = (Topic)topicsIterator.next();
			topicNameCollection = (Collection)baseNamesExtractor.fn(topicTypeTopic2);
			Object[] objectArray4 = topicNameCollection.toArray();

			if(java.lang.reflect.Array.getLength(objectArray4) == 0){
				topicBaseName = "No Name";
			}
			else{
				topicBaseName = ((BaseName)(objectArray4[0])).getData();
			}

			if(topicBaseName.compareTo(topicType) == 0){
				propTopic = topicTypeTopic2;
				System.out.println("TopicBaseName = " + topicBaseName);
			}
		}

		extractProps();
		return topicPropsArrayList;
	}

	public void extractProps(){

		Collection occCol = propTopic.getOccurrences();
		Iterator occIt = occCol.iterator();
		System.out.println("Number of occurrences = "+occCol.size());
		String[] topicOccurrences = new String[occCol.size()];
		String[] topicOccLocatorAddress = new String[occCol.size()];
		String[] topicOccLocatorNotation = new String[occCol.size()];
		for(int g=0;g<occCol.size();g++){
			Occurrence occ2 = (Occurrence)occIt.next();
			String occData = occ2.getData();
			if(occData!=null){
				topicOccurrences[g] = occData;
			}
			else{
				Locator resourceLoc = occ2.getDataLocator();
				String locAddress = resourceLoc.getAddress();
				String locNotation = resourceLoc.getNotation();
				topicOccLocatorAddress[g] = locAddress;
				topicOccLocatorNotation[g] = locNotation;
			}
			System.out.println("Occurrence data = " + topicOccurrences[g]);
		}
		topicPropsArrayList.add(topicOccurrences);
		topicPropsArrayList.add(topicOccLocatorAddress);
		topicPropsArrayList.add(topicOccLocatorNotation);

	}

	public String[] extractTopicsOfType(TopicMap map, String topicType){

		tm = map;
		topicSet2 = tm.getTopics();
		anotherSet = tm.getTopics();
		System.out.println("collection size = " + anotherSet.size());
		topics = tm.getTopicCount();
		topicsIterator = anotherSet.iterator();
		System.out.println("har iterator");

		while(topicsIterator.hasNext()){

			topicTypeTopic2 = (Topic)topicsIterator.next();

			topicNameCollection = (Collection)baseNamesExtractor.fn(topicTypeTopic2);

			Object[] objectArray3 = topicNameCollection.toArray();

			if(java.lang.reflect.Array.getLength(objectArray3) == 0){
				topicBaseName = "No Name";
			}

			else{
				topicBaseName = ((BaseName)(objectArray3[0])).getData();
			}

			System.out.println("topicBaseName = " + topicBaseName);
			System.out.println("topicType = " + topicType);

			if(topicBaseName.compareTo(topicType) == 0){
				topicTypeTopic3 = topicTypeTopic2;
			}

		}


		if(topicTypeTopic3 != null){

			Collection goOn = (Collection)baseNamesExtractor.fn(topicTypeTopic3);
			Object[] goOnOn = goOn.toArray();
			String goOnAndOn = ((BaseName)(goOnOn[0])).getData();
			System.out.println("name of typing topic = " + goOnAndOn);
		}

		TopicMapUtilsImpl topicMapUtilsImpl = new TopicMapUtilsImpl(tm);

		topicsOfTypeCollection = topicMapUtilsImpl.getObjectsOfType(topicTypeTopic3, topicSet2);
		System.out.println("number of topics to be filtered = " + topicSet2.size());
		System.out.println("number of elements in collection = " + topicsOfTypeCollection.size());

		Topic[] topicsOfTypeArray = (Topic[]) topicsOfTypeCollection.toArray(new Topic[0]);

		int numberOfTopics2 = java.lang.reflect.Array.getLength(topicsOfTypeArray);
		System.out.println("numberOfTopics2 = " + numberOfTopics2);

		topicsOfTypeString = new String[numberOfTopics2];


		do{
			System.out.println("hoihoi");
			topicTypeTopic = topicsOfTypeArray[k];
			topicNameCollection = (Collection)baseNamesExtractor.fn(topicTypeTopic);

			Object[] objectArray2 = topicNameCollection.toArray();

			if(java.lang.reflect.Array.getLength(objectArray2) == 0){
				topicsOfTypeString[k] = "NoName";
			}
			else{
				String utNavn3 = ((BaseName)(objectArray2[0])).getData();
				topicsOfTypeString[k] = utNavn3;
			}
			k++;
			System.out.println(k);
		}while(k<numberOfTopics2);

		return topicsOfTypeString;
	}

	// Get the topics in a topic map
    public String[] extractTopic(TopicMap map) {

		tm = map;
        topicSet = tm.getTopics();
		numberOfTopics = tm.getTopicCount();

        topicNames = new String[numberOfTopics];

        objectArray = new Object[numberOfTopics];

		objectArray = topicSet.toArray(objectArray);

		do{
			topicInArray = (Topic)(objectArray[i]);
			topicNameCollection = (Collection)baseNamesExtractor.fn(topicInArray);

			//Converting Collection to Object[]
			Object[] objectArray2 = topicNameCollection.toArray();

			//Retrieving first BaseName in Object[]
			if(java.lang.reflect.Array.getLength(objectArray2) == 0){
				topicNames[i] = "NoName";
			}

			else{
				String utNavn2 = ((BaseName)(objectArray2[0])).getData();

				topicNames[i] = utNavn2;

			}

			topicTypeCollection = topicInArray.getTypes();

			if(!topicTypeCollection.isEmpty()){
				Topic[] topicTypeArray;
				Topic[] topicTypeArray2 = (Topic[]) topicTypeCollection.toArray(new Topic[0]);

				if(!topicTypes.contains(topicTypeArray2[0])){
					topicTypes.add(topicTypeArray2[0]);
				}
			}

			//Incrementing counter i, and collecting next topic from objectArray[]
			i++;

		}while(i<numberOfTopics);

		return topicNames;
    }

	// Get the topic types in a topic map
    public String[] getTopicTypes(){

		int topicTypesSize = topicTypes.size();
		topicTypesString = new String[topicTypesSize];

		for(int f = 0;f<topicTypesSize;f++){
			Topic top = (Topic)topicTypes.get(f);
			Collection topicTypeCollection = (Collection)baseNamesExtractor.fn(top);
			Object[] obArray = topicTypeCollection.toArray();

			if(java.lang.reflect.Array.getLength(obArray) == 0){
				topicTypesString[f] = "NoName";
			}

			else{
				String typeName = ((BaseName)(obArray[0])).getData();
				topicTypesString[f] = typeName;
			}
		}

		return topicTypesString;
	}

}
